from java.awt import Color,Font
from jhplot  import *
from jhpro.sregression import *


# masses divided by the plank mass Mp=1.22089E19 GeV/c 
mUmP=2.1E-22 # up  1.4E-22 - 2.7E-22
mDmP=4.0E-22 # down 3.4E-22 - 4.8E-22
mSmP=8.27E-21 # s-quark
mCmP=1.04E-19 # charm
mBmP=3.43E-19 # b-quarks
mTmP=1.41E-17 # top

# CKM matrix
Vud=0.97428 # +- 0.00015 
Vus=0.2253  # +- 0.0007 
Vub=0.00347 # +- 0.000016
Vcd=0.2252  # +- 0.00007
Vcs=0.97345 # +- 0.00015
Vcb=0.0410  # +- 0.0012
Vtd=0.00862 # +-0.0002
Vts=0.0403  # +-0.0007
Vtb=0.999152 # +- 0.000045


data=PND("data")
data.add([mUmP/mDmP,Vud])
data.add([mUmP/mSmP,Vus])
data.add([mUmP/mBmP,Vub])
data.add([mCmP/mDmP,Vcd])
data.add([mCmP/mSmP,Vcs])
data.add([mCmP/mBmP,Vcb])
data.add([mTmP/mDmP,Vtd])
data.add([mTmP/mSmP,Vts])
data.add([mTmP/mBmP,Vtb])


print data.toString()


print data.toString()
conf=[]
conf.append("presentation: P(4)")
conf.append("num_input_variables: 1")
conf.append("variable_names: x y")
#conf.append("functions: Sqrt")
# conf.append("functions: Add,Subtract,Multiply,Divide,Square")
conf.append("functions: Add,Subtract,Multiply,Divide,Pow,Log,Sine,Sqrt,ArcSine,Cosine,Exp")
conf.append("terminal_range: -20 20")
conf.append("max_init_depth: 4")
conf.append("population_size: 1000")
conf.append("max_crossover_depth: 8")
conf.append("max_crossover_depth: 8")
conf.append("num_evolutions: 800")
conf.append("max_nodes: 20")
conf.append("stop_criteria_fitness: 0.1")
js=SymRegression(data,conf)
js.run()


# create a tree as image
# IView("/home/sergei/a.png")
print "Best solution=",js.getBestSolution()
# js.createTree("/home/sergei/a.png")

data=js.getDataPND() # extract original data for plotting
print data.toString()

conf=js.getConfigArray()
print conf.toString()

#val=js.getValidationPND()
#print val.toString()


c1 = HPlot("Canvas")
c1.setGTitle("Symbolic regression")
c1.visible(1)
c1.setAutoRange()
f1=F1D(js.getBestSolution(),0,40)
f1.setTitle("best analytic solution")
c1.draw(f1)

r12=data.getP1D(0,1) # extract 0 and 1 columns
r12.setColor(Color.blue)
c1.draw(r12)


